

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable offline 0


    variable Rmsg
    variable Wmsg

    variable ModuleName v1495
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable V1495RegisterMap {}
    lappend V1495RegisterMap {Firmware Firmware_Rev}
    lappend V1495RegisterMap {Scratch16 Scratch16}
    lappend V1495RegisterMap {Scratch32 Scratch32}

    variable DPPRegisterMap {}
    lappend DPPRegisterMap {Version Version}
    lappend DPPRegisterMap {"Accepted Trigger Scaler" AcceptedTriggers}
    lappend DPPRegisterMap {"NonAccepted Trigger Scaler" NonAcceptedTriggers}
    lappend DPPRegisterMap {"Control Register" Ctrl}
    lappend DPPRegisterMap {"Trigger Width" TriggerWidth}
    lappend DPPRegisterMap {"Trigger Channel" TriggerChannel}
    lappend DPPRegisterMap {"Single Shot Status" Arm}
    lappend DPPRegisterMap {"Diagnostic Delay" DiagDelay}

    lappend DPPRegisterMap {InputPort1 InputPort1}
    lappend DPPRegisterMap {InputPort2 InputPort2}
    lappend DPPRegisterMap {InputPort3 InputPort3}
    lappend DPPRegisterMap {OutputPort1 OutputPort1}
    lappend DPPRegisterMap {OutputPort2 OutputPort2}
    lappend DPPRegisterMap {OutputPort3 OutputPort3}
    lappend DPPRegisterMap {InputMask1 InputMask1}
    lappend DPPRegisterMap {InputMask2 InputMask2}
    lappend DPPRegisterMap {InputMask3 InputMask3}
    lappend DPPRegisterMap {UserValue1 UserValue1}
    lappend DPPRegisterMap {UserValue2 UserValue2}
    lappend DPPRegisterMap {UserValue3 UserValue3}
    lappend DPPRegisterMap {UserValue4 UserValue4}
    lappend DPPRegisterMap {IDD IDD}
    lappend DPPRegisterMap {IDE IDE}
    lappend DPPRegisterMap {IDF IDF}

    variable DPPSettings {}
    lappend DPPSettings {"Control Register" Ctrl}
    lappend DPPSettings {"Trigger Width" TriggerWidth}
    lappend DPPSettings {"Trigger Channel" TriggerChannel}
    lappend DPPSettings {"Single Shot Arm" Arm}
    lappend DPPSettings {"Diagnostic Delay" DiagDelay}
    lappend DPPSettings {InputMask1 InputMask1}
    lappend DPPSettings {InputMask2 InputMask2}
    lappend DPPSettings {InputMask3 InputMask3}
    lappend DPPSettings {UserValue1 UserValue1}
    lappend DPPSettings {UserValue2 UserValue2}
    lappend DPPSettings {UserValue3 UserValue3}
    lappend DPPSettings {UserValue4 UserValue4}



     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable alladcs
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {

   }


    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           DBSetValue Scratch16   [ReadRegister Scratch16]
           DBSetValue Scratch32   [ReadRegister Scratch32]

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName

        set SAV1 $ModuleIndex

        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

        set ModuleIndex $SAV1
    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                  ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   SETTING     {WriteRegister [lindex $w 1] [lindex $w 2]}
                   SOFTRESET   {WriteRegister Reset 0}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

