
#    Note:  This is loaded into the namespace  VMEConfig

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleMenu

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000
    
    variable ModuleType
    variable ModuleName
    variable ModuleAddress
    variable NumModules 16

    for {set i 1} {$i <= $NumModules} {incr i} {
       set ModuleType($i) ""
       set ModuleName($i) ""
       set ModuleAddress($i) ""
    }

   variable moduletype [first $ModuleMenu]
   variable moduleindex 1

   variable index 0

#    register access procedures

   proc InterfaceReset {} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer InterfaceReset} msg]
       if {$z != 0} {
           InsertLog "InterfaceReset failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc DeleteRegisters {pattern} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer DeleteRegisters $pattern} msg]

       if {$z == 0} {
           InsertLog "DeleteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "DeleteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
  }
 
  proc DefineRegister {modname class regname attr} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer DefineRegister  $modname.$regname $class $attr} msg]

       if {$z == 0} {
#           InsertLog "DefineRegister ($modname.$regname) returned: [lindex $msg 5]"
       } else {
           InsertLog "DefineRegister ($modname.$regname) failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
  }

   proc ReadRegister {RegName} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $RegName} msg]

       if {$z == 0} {
           set rc [lindex $msg 5]
#           InsertLog "ReadRegister $RegName returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister $RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $RegName $RegData} msg]

       if {$z == 0} {
#           InsertLog "WriteRegister $RegName $RegData [format 0x%x $RegData] returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegister RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable LogFlag
        variable ShowLogFlag
        variable moduletype
        variable moduleindex
        variable index

        InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base"
        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "moduletype=$moduletype; moduleindex=$moduleindex; index=$index"
        InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
   }
   
      proc do_Add {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype     
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleType($i)] == ""} {break}
          }
          
          if {[set ModuleType($i)] != ""} {
            Alert "Module table full"
            return
          }
          
          set ModuleType($i) $moduletype
          set ModuleAddress($i) "$A16Base:$A24Base:$A32Base"
          
          switch $moduletype {
             CAEN_V785   {set ModuleName($i) v785#$moduleindex}
             CAEN_V775   {set ModuleName($i) v775#$moduleindex}
             CAEN_V830   {set ModuleName($i) v830#$moduleindex}
             CAEN_V560   {set ModuleName($i) v560#$moduleindex}
             CAEN_V1724  {set ModuleName($i) v1724#$moduleindex}
             CAEN_V1190  {set ModuleName($i) v1190#$moduleindex}
             CAEN_V1290  {set ModuleName($i) v1290#$moduleindex}
             CAEN_V1495  {set ModuleName($i) v1495#$moduleindex}
             default     {set ModuleName($i) [string tolower $moduletype]#$moduleindex}
          }
      
      }
       
      proc do_Replace {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype    
        variable index 
      
          if {[set ModuleType($index)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
          set ModuleType($index) $moduletype
          set ModuleAddress($index) "$A16Base:$A24Base:$A32Base"
          
          switch $moduletype {
             CAEN_V785   {set ModuleName($index) v785#$moduleindex}
             CAEN_V775   {set ModuleName($index) v775#$moduleindex}
             CAEN_V830   {set ModuleName($index) v830#$moduleindex}
             CAEN_V560   {set ModuleName($index) v560#$moduleindex}
             CAEN_V1724  {set ModuleName($index) v1724#$moduleindex}
             CAEN_V1190  {set ModuleName($index) v1190#$moduleindex}
             CAEN_V1290  {set ModuleName($index) v1290#$moduleindex}
             CAEN_V1495  {set ModuleName($index) v1495#$moduleindex}
             default     {set ModuleName($index) [string tolower $moduletype]#$moduleindex}
          }
      
      }
      
      proc do_Restore {} {
        variable ConfigBase
        variable ModuleType
        variable ModuleName
        variable ModuleAddress

        InsertLog "Restoring VME Configuration"

        set ConfigFile [file join $ConfigBase VMEConfig.dat]

        set z [catch {open $ConfigFile r} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Load unable to access $ConfigFile: [set file]"
            return
        }

        set i 1
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set ModuleType($i) [first $item]
            set ModuleName($i) [second $item]
            set ModuleAddress($i) [third $item]
            incr i 1
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Configuration restored from $ConfigFile"
    }

      proc do_Select {i} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable index
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype    
      
         if {[set ModuleType($i)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
         set index $i
         set A16Base [first [split [set ModuleAddress($i)] :]]
         set A24Base [second [split [set ModuleAddress($i)] :]]
         set A32Base [third [split [set ModuleAddress($i)] :]]
         
         set moduletype [set ModuleType($i)]
         set moduleindex [second [split [set ModuleName($i)] #]]
    }
    
      proc do_Delete {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable index

         if {[set ModuleType($index)] == ""} {
            Alert "Module entry not in use"
            return
          }
          
       set ModuleType($index) ""
       set ModuleName($index) ""
       set ModuleAddress($index) ""
    }
    
      proc do_Clear {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules  
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             set ModuleType($i) ""
             set ModuleName($i) ""
             set ModuleAddress($i) ""
          }
      }
  
      proc do_Save {} {
        variable ConfigBase
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
      
        InsertLog "Saving VME Configuration"

        set ConfigFile [file join $ConfigBase VMEConfig.dat]

        set z [catch {open $ConfigFile w} file]
        if {$z != 0} {
            Alert "Unable to access $ConfigFile"
            InsertLog "Save unable to access $ConfigFile: [set file]"
            return
        }
        
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleType($i)] == ""} {continue}
             puts $file "[set ModuleType($i)] [set ModuleName($i)] [set ModuleAddress($i)]"
          }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Configuration saved to $ConfigFile"
    }
    
      proc do_Activate {} {
       global env
       global errorCode errorInfo
        variable ConfigBase
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
      
        InsertLog "Activating new VME Configuration"

        DeleteRegisters *     ;#    first delete existing registers
        ::VMEConfig::InterfaceReset
        ::VMEConfig::WriteRegister HasBeenConfigured 0

        puts "Cleared all registers"

        for {set ii 1} {$ii <= $NumModules} {incr ii} {
             if {[set ModuleType($ii)] == ""} {continue}
           
#             puts "[set ModuleType($ii)] [set ModuleName($ii)] [set ModuleAddress($ii)]"

             switch [set ModuleType($ii)] {
                 CAEN_V785  {set m V785}
                 CAEN_V775  {set m V775}
                 CAEN_V560  {set m V560}
                 CAEN_V830  {set m V830}
                 CAEN_V1724 {set m V1724}
                 CAEN_V1190 {set m V1190}
                 CAEN_V1290 {set m V1290}
                 CAEN_V1495 {set m V1495}
                 default    {set m [set ModuleType($ii)]}
             }

             if {$m != ""} {
                 set AddressData [set ModuleAddress($ii)]
                 set Module [set ModuleName($ii)]
                 set z [catch {source [file join $env(MIDASBASE) TclHttpd Html VME $m $m.defn.tcl]} msg]
                 if {$z != 0} {Alert "Module may not be supported: $m\n$msg"}
             }
        }

        ::VMEConfig::WriteRegister HasBeenConfigured 1
        InsertLog "Done"

        Elog INFORMATION "VME Configuration activated"
    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]}
                             A24   {variable A24Base; set A24Base [lindex $w 2]}
                             A32   {variable A32Base; set A32Base [lindex $w 2]}
                         }
                   }

                ADD     {do_Add}
                REPLACE {do_Replace}
                DELETE  {do_Delete}
                CLR     {do_Clear}
                SAVE    {do_Save}
                RESTORE {do_Restore}
                ACTIVATE {do_Activate}
                IFRESET {::VMEConfig::InterfaceReset}

                INDEX {variable moduleindex; set moduleindex [lindex $w 1]}
                TYPE  {variable moduletype;  set moduletype [lindex $w 1]}
      
                CONFIG  {do_Select [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

